/* my.c */	extern char *myFormatName();
/* my.c */	extern char *myGetName();
/* my.c */	extern char *myObjectName();
/* my.c */	extern int myOctFailed();
/* my.c */	extern myPrintObject();
/* my.c */	extern octStatus CreatePath2();
/* my.c */	extern octStatus myActualTerminalBB();
/* my.c */	extern octStatus myAttachContainers();
/* my.c */	extern octStatus myAttachContents();
/* my.c */	extern octStatus myContentsToArray();
/* my.c */	extern octStatus myCopyContents();
/* my.c */	extern octStatus myCountContents();
/* my.c */	extern octStatus myDeleteContents();
/* my.c */	extern octStatus myFindFormal();
/* my.c */	extern octStatus myFormalTerminalBB();
/* my.c */	extern octStatus myFormalTerminalNet();
/* my.c */	extern octStatus myGetByNameContainer();
/* my.c */	extern octStatus myGetPoints();
/* my.c */	extern octStatus myModifyInstance();
/* my.c */	extern octStatus myOpen();
/* my.c */	extern octStatus myOpenMaster();
/* my.c */	extern octStatus myPrintObjects();
/* my.c */	extern octStatus myPrintObjects2();
/* my.c */	extern octStatus myScaleContents();
/* my.c */	extern octStatus myScaleFacet();
/* my.c */	extern octStatus mySortContents();
/* my.c */	extern octStatus myTerminalBB();
/* my.c */	extern octStatus myTransformContents();
/* my.c */	extern octStatus myUniqNames();

extern octStatus myLastStatus;

#define OCT_ASSERT(fct) 			\
    ((myLastStatus = fct) == OCT_OK) ? 0 : 	\
	myOctFailed(__FILE__, __LINE__, (char *) 0, (octObject *) 0)

#define OCT_ASSERT_DESCR(fct, why) 		\
    ((myLastStatus = fct) == OCT_OK) ? 0 : 	\
	myOctFailed(__FILE__, __LINE__, why, (octObject *) 0)

#define OCT_FAIL(fct, why, offending_object)	\
    ((myLastStatus = fct) == OCT_OK) ? 0 : 	\
	myOctFailed(__FILE__, __LINE__, why, offending_object)

#define CHECK(fct)				\
    if ((myLastStatus = (fct)) < OCT_OK) return myLastStatus;


#ifdef RPC

#define vemPrint(string) \
    vemMessage(string, MSG_DISP | MSG_NOLOG)

#endif

#define myGenFirst		octGenFirstContent
#define myGenFirstContainer	octGenFirstContainer

/*
 *  Macro's to call octGetByName()
 *	c = the container
 *	t = the object
 *	s = the object name
 */

#define GetByTermName(c, t, s)				\
    ((t)->type=OCT_TERM, (t)->contents.term.name=s, octGetByName(c,t))

#define GetByNetName(c, t, s)				\
    ((t)->type=OCT_NET, (t)->contents.net.name=s, octGetByName(c,t))

#define GetByInstName(c, t, s)				\
    ((t)->type=OCT_INSTANCE,(t)->contents.instance.name=s, octGetByName(c,t))

#define GetByLabelName(c, t, s)				\
    ((t)->type=OCT_LABEL, (t)->contents.label.label=s, octGetByName(c,t))

#define GetByBagName(c, t, s)				\
    ((t)->type=OCT_BAG, (t)->contents.bag.name=s, octGetByName(c,t))

#define GetByLayerName(c, t, s)				\
    ((t)->type=OCT_LAYER, (t)->contents.layer.name=s, octGetByName(c,t))

#define GetByPropName(c, t, s)				\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s, octGetByName(c,t))

/*
 *  Macro's to call octCreate()
 *	c = the container
 *	t = the object
 *	s = the object name (for named objects)
 */

#define CreateTerm(c, t, s)				\
    ((t)->type=OCT_TERM, (t)->contents.term.name=s, 	\
    (t)->contents.term.instanceId = oct_null_id, octCreate(c,t))

#define CreateNet(c, t, s)				\
    ((t)->type=OCT_NET, (t)->contents.net.name=s, octCreate(c,t))

#define CreateLabel(c, t, s, zx, zy)			\
    ((t)->type=OCT_LABEL, 				\
    (t)->contents.label.label = s, 			\
    octCreate(c,t))

#define CreateBag(c, t, s)				\
    ((t)->type=OCT_BAG, (t)->contents.bag.name=s, octCreate(c,t))

#define CreateLayer(c, t, s)				\
    ((t)->type=OCT_LAYER, (t)->contents.layer.name=s, octCreate(c,t))

#define CreatePath(c, t, w)				\
    ((t)->type=OCT_PATH, (t)->contents.path.width=w, octCreate(c,t))

#define CreatePropInt(c, t, s, i)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_INTEGER, 		\
    (t)->contents.prop.value.integer = i,		\
    octCreate(c,t))

#define CreatePropStr(c, t, s, s1)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_STRING, 		\
    (t)->contents.prop.value.string = s1,		\
    octCreate(c, t))

#define CreatePropReal(c, t, s, d)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_REAL, 		\
    (t)->contents.prop.value.real = d,			\
    octCreate(c, t))

#define CreateInstance(c, t, xname, xmaster, xview, xfacet, tx, ty, ttype)\
    ((t)->type=OCT_INSTANCE, 				\
    (t)->contents.instance.name = xname,		\
    (t)->contents.instance.master = xmaster, 		\
    (t)->contents.instance.view = xview,		\
    (t)->contents.instance.facet = xfacet,		\
    (t)->contents.instance.version = OCT_CURRENT_VERSION,\
    (t)->contents.instance.transform.translation.x = tx,\
    (t)->contents.instance.transform.translation.y = ty,\
    (t)->contents.instance.transform.transformType = ttype,\
    octCreate(c, t))

#define CreateInst(c, t, xname, xmaster, xview, xfacet)		\
    CreateInstance(c, t, xname, xmaster, xview, xfacet, 0, 0, OCT_NO_TRANSFORM)

#define CreateBox(c, t, llx, lly, urx, ury)		\
    ((t)->type = OCT_BOX, 				\
    (t)->contents.box.lowerLeft.x = llx, 		\
    (t)->contents.box.lowerLeft.y = lly,		\
    (t)->contents.box.upperRight.x = urx, 		\
    (t)->contents.box.upperRight.y = ury,		\
    octCreate(c, t))

#define CreateCircle(c, t, startAng, endAng, inRad, outRad, cx, cy)\
    ((t)->type = OCT_CIRCLE, 				\
    (t)->contents.circle.startingAngle = startAng,	\
    (t)->contents.circle.endingAngle = endAng,		\
    (t)->contents.circle.innerRadius = inRad,		\
    (t)->contents.circle.outerRadius = outRad,		\
    (t)->contents.circle.center.x = cx,			\
    (t)->contents.circle.center.y = cy,			\
    octCreate(c, t))

#define CreateSprop	CreatePropStr
#define CreateIprop	CreatePropInt
#define CreateRprop	CreatePropReal

/*
 *  Macro's to call octGetOrCreate()
 *	c = the container
 *	t = the object
 *	s = name of the object
 */

#define GetOrCreateTerm(c, t, s)			\
    ((t)->type=OCT_TERM, (t)->contents.term.name=s, octGetOrCreate(c,t))

#define GetOrCreateNet(c, t, s)				\
    ((t)->type=OCT_NET, (t)->contents.net.name=s, octGetOrCreate(c,t))

#define GetOrCreateLabel(c, t, s)			\
    ((t)->type=OCT_LABEL, (t)->contents.label.label=s, octGetOrCreate(c,t))

#define GetOrCreateBag(c, t, s)				\
    ((t)->type=OCT_BAG, (t)->contents.bag.name=s, octGetOrCreate(c,t))

#define GetOrCreateLayer(c, t, s)			\
    ((t)->type=OCT_LAYER, (t)->contents.layer.name=s, octGetOrCreate(c,t))

#define GetOrCreatePropInt(c, t, s, i)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_INTEGER, 		\
    (t)->contents.prop.value.integer = i,		\
    octGetOrCreate(c,t))

#define GetOrCreatePropStr(c, t, s, s1)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_STRING, 		\
    (t)->contents.prop.value.string = s1,		\
    octGetOrCreate(c, t))

#define GetOrCreatePropReal(c, t, s, d)			\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_REAL, 		\
    (t)->contents.prop.value.real = d,			\
    octGetOrCreate(c, t))

#define GetOrCreateSprop GetOrCreatePropStr
#define GetOrCreateIprop GetOrCreatePropInt
#define GetOrCreateRprop GetOrCreatePropReal

/*
 *  Macro's to call octCreateOrModify()
 *	c = the container
 *	t = the object
 *	s = name of the object
 */

#define CreateOrModifyTerm(c, t, s)			\
    ((t)->type=OCT_TERM, (t)->contents.term.name=s, octCreateOrModify(c,t))

#define CreateOrModifyNet(c, t, s)			\
    ((t)->type=OCT_NET, (t)->contents.net.name=s, octCreateOrModify(c,t))

#define CreateOrModifyLabel(c, t, s)			\
    ((t)->type=OCT_LABEL, (t)->contents.label.label=s, octCreateOrModify(c,t))

#define CreateOrModifyBag(c, t, s)			\
    ((t)->type=OCT_BAG, (t)->contents.bag.name=s, octCreateOrModify(c,t))

#define CreateOrModifyLayer(c, t, s)			\
    ((t)->type=OCT_LAYER, (t)->contents.layer.name=s, octCreateOrModify(c,t))

#define CreateOrModifyPropInt(c, t, s, i)		\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_INTEGER, 		\
    (t)->contents.prop.value.integer = i,		\
    octCreateOrModify(c,t))

#define CreateOrModifyPropStr(c, t, s, s1)		\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_STRING,		\
    (t)->contents.prop.value.string = s1,		\
    octCreateOrModify(c, t))

#define CreateOrModifyPropReal(c, t, s, d)		\
    ((t)->type=OCT_PROP, (t)->contents.prop.name=s,	\
    (t)->contents.prop.type = OCT_REAL,			\
    (t)->contents.prop.value.real = d,			\
    octCreateOrModify(c, t))

#define CreateOrModifySprop CreateOrModifyPropStr
#define CreateOrModifyIprop CreateOrModifyPropInt
#define CreateOrModifyRprop CreateOrModifyPropReal

/*
 *  Get object by id
 */
#define GetById(obj, id)				\
    ((obj)->objectId = id, octGetById(obj))

#define OpenFacet(t, c, v, f, m)			\
    ((t)->type = OCT_FACET, 				\
    (t)->contents.facet.cell = c, 			\
    (t)->contents.facet.view = v,			\
    (t)->contents.facet.facet = f, 			\
    (t)->contents.facet.version = OCT_CURRENT_VERSION,	\
    (t)->contents.facet.mode = m, 			\
    octOpenFacet(t))

#define OpenMaster(t, i, f, m)				\
    ((t)->type = OCT_FACET, 				\
    (t)->contents.facet.facet = f, 			\
    (t)->contents.facet.version = OCT_CURRENT_VERSION,	\
    (t)->contents.facet.mode = m, 			\
    octOpenMaster(i, t))


#define OpenInterface(t, f, m)				\
    ((t)->type = OCT_FACET, 				\
    (t)->contents.facet.cell = (f)->contents.facet.cell,\
    (t)->contents.facet.view = (f)->contents.facet.view,\
    (t)->contents.facet.facet = "interface",		\
    (t)->contents.facet.version = OCT_CURRENT_VERSION,	\
    (t)->contents.facet.mode = m, 			\
    octOpenFacet(t))
